Name: 		qpid-jca

%global main_install_dir %{_datadir}/%{name}
%global zip_install_dir %{_datadir}/%{name}-zip
%global xarecovery_install_dir %{_datadir}/%{name}-xarecovery

Version: 	0.14
Release: 	9%{?dist}
Summary: 	JCA resource adapter for Apache Qpid
License: 	Apache Software License
Group: 		Development/Java
URL: 		http://qpid.apache.org/

%global qpid_src_dir qpid-%{version}
%global qpid_deps_src_dir qpid-deps
%global jca_deps_src_dir qpid-jca-deps
%global xarecovery_src_dir qpid-jca-xarecovery-0.2
%global xarecovery_deps_src_dir qpid-jca-xarecovery-deps-0.2

Source0:        %{qpid_src_dir}.tar.gz
Source1:        %{qpid_deps_src_dir}.tar.gz
Source2:        %{jca_deps_src_dir}.tar.gz
Source3:        %{xarecovery_src_dir}.tar
Source4:        %{xarecovery_deps_src_dir}.tar

Patch0:         mrg.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      noarch
BuildRequires:  ant >= 1.6.5
BuildRequires:  ant-nodeps >= 1.6.5
BuildRequires:  java-devel >= 1.6.0
BuildRequires:  ant-trax >= 1.6.5

# XXX no longer required
# BuildRequires:  qpid-java-client = %{version}
# BuildRequires:  qpid-java-common = %{version}

%description
JCA Resource adapter for Apache Qpid.

%package zip
Summary:        Zip for JCA resource adapter for Apache Qpid
Group:          Development/Java
BuildArch:      noarch

%description zip
Zip file for JCA resource adapter for Apache Qpid

%package xarecovery
Summary:        JBoss XA recovery for Apache Qpid JCA resource adapter 
Group:          Development/Java
BuildArch:      noarch
Requires:       %{name} = %{version}-%{release}

%description xarecovery
XA Recovery module for Apache Qpid JCA resource adapter running under JBoss
Application Server

%prep
%setup -q -n %{qpid_src_dir}
%patch0 -p2

%setup -q -T -b 1 -n %{qpid_deps_src_dir}
%setup -q -T -b 2 -n %{jca_deps_src_dir}
%setup -q -T -b 3 -n %{xarecovery_src_dir}
%setup -q -T -b 4 -n %{xarecovery_deps_src_dir}

%build
cd ..

(cd %{jca_deps_src_dir}; ant -Dqpid-src-dir=../%{qpid_src_dir}/java)

(
    cd %{qpid_src_dir}/java
    ant -Dmodules="junit-toolkit common client jca"

    #BLACKLIST="qpid-junit-toolkit geronimo-jms junit slf4j qpid-client-tests qpid-all qpid-common-tests log4j"
    #for jar in $BLACKLIST; do rm build/lib/${jar}*.jar; done
)

(cd %{qpid_deps_src_dir}; ant -Dqpid-src-dir=../%{qpid_src_dir}/java -Dversion=%{version})

(
    cd %{qpid_src_dir}/java
    rm jca/example/.gitignore
    cp build/lib/qpid-deps-%{version}.jar jca/example/lib
)

(
    cd %{xarecovery_deps_src_dir}
    ant

    # Missing build deps
    cp ../%{qpid_src_dir}/java/build/lib/qpid-deps-%{version}.jar lib
    cp ../%{qpid_src_dir}/java/build/lib/log4j-slf4j.jar lib
    cp ../%{qpid_src_dir}/java/build/lib/slf4j-api-1.6.1.jar lib
)

(
    cd %{xarecovery_src_dir}
    ant -Dlib.dir=../%{xarecovery_deps_src_dir}/lib \
        -Dqpid.client.dir=../%{qpid_src_dir}/java/build/lib \
        package
)

# XXX Where precisely does this need to go?
# # blacklisted jars are either provided by the Requires: or not needed.
# BLACKLIST="geronimo-jms  jbossjts  slf4j-api"
# for jar in $BLACKLIST; do rm lib/${jar}*.jar; done

%install
rm -rf %{buildroot}

cd ..

# jca

install -dm 755 %{buildroot}%{main_install_dir}
install -pm 755 %{qpid_src_dir}/java/build/lib/qpid-ra-%{version}.rar %{buildroot}%{main_install_dir}
install -pm 644 %{qpid_src_dir}/java/jca/README.txt %{buildroot}%{main_install_dir}
install -pm 644 %{qpid_src_dir}/java/jca/README-*.txt %{buildroot}%{main_install_dir}

# XXX Previous rpms don't have these
#install -pm 755 %{qpid_src_dir}/java/build/lib/log4j-slf4j.jar %{buildroot}%{main_install_dir}
#install -pm 755 %{qpid_src_dir}/java/build/lib/qpid-deps-%{version}.jar %{buildroot}%{main_install_dir}

# XXX These are already in the .rar
#install -pm 755 %{qpid_src_dir}/java/build/lib/qpid-client-%{version}.jar %{buildroot}%{main_install_dir}
#install -pm 755 %{qpid_src_dir}/java/build/lib/qpid-common-%{version}.jar %{buildroot}%{main_install_dir}

# XXX Not present in current jca dir
#install -pm 644 %{qpid_src_dir}/java/jca/*-ds.xml %{buildroot}%{main_install_dir}

# jca-zip

(
    tmpdir=$(mktemp -d)

    mkdir $tmpdir/%{name}-%{version}

    cp -r %{buildroot}%{main_install_dir} $tmpdir/%{name}-%{version}
 
    (cd $tmpdir; zip -q -9 -r %{name}-%{version}.zip %{name}-%{version})

    install -dm 755 %{buildroot}%{zip_install_dir}
    install -pm 644 $tmpdir/%{name}-%{version}.zip %{buildroot}%{zip_install_dir}
)

# xarecovery

install -dm 755 %{buildroot}%{xarecovery_install_dir}
install -pm 644 %{xarecovery_src_dir}/README.txt \
    %{buildroot}%{xarecovery_install_dir}/README-jboss.txt
install -pm 644 %{xarecovery_src_dir}/jbossts-properties.xml \
    %{buildroot}%{xarecovery_install_dir}
install -pm 755 %{xarecovery_src_dir}/build/qpid-xarecovery-jboss.jar \
    %{buildroot}%{xarecovery_install_dir}

%clean
rm -rf %{buildroot}

%files 
%defattr(-,root,root,-)
%{main_install_dir}
%doc ../%{qpid_src_dir}/java/resources/LICENSE
%doc ../%{qpid_src_dir}/java/resources/NOTICE
%doc ../%{qpid_src_dir}/java/jca/example

%files zip
%defattr(-,root,root,-)
%{zip_install_dir}
%doc ../%{qpid_src_dir}/java/resources/LICENSE

%files xarecovery
%defattr(-,root,root,-)
%{xarecovery_install_dir}
%doc ../%{xarecovery_src_dir}/LICENSE

%changelog
* Thu Feb 23 2012 Justin Ross <jross@redhat.com> - 0.14-9
- Resolves:rhbz#796907
- Resolves:rhbz#796932

* Thu Feb 16 2012 Justin Ross <jross@redhat.com> - 0.14-8
- Resolves:rhbz#773700
- Resolves:rhbz#786875
- Resolves:rhbz#787146

* Fri Feb 1 2012 Justin Ross <jross@redhat.com> - 0.14-7
- Resolves:rhbz#768384
- Resolves:rhbz#768369
- Resolves:rhbz#752381
- Resolves:rhbz#785014

* Fri Jan 20 2012 Justin Ross <jross@redhat.com> - 0.14-5
- Resolves:rhbz#759235
- Resolves:rhbz#782693
- Resolves:rhbz#782774
- Resolves:rhbz#782454

* Thu Jan 12 2012 Ted Ross <tross@redhat.com> - 0.14-4
- Resolves:rhbz#768366

* Wed Jan 11 2012 Ted Ross <tross@redhat.com> - 0.14-3
- Fixed a dependency issue between qpid-jca-xarecovery and qpid-jca
- Trimmed the size of the mrg.patch file to eliminate unused parts of the qpid tree

* Wed Jan 11 2012 Ted Ross <tross@redhat.com> - 0.14-2
- Resolves:rhbz#768374
- Resolves:rhbz#768364
- Resolves:rhbz#759235
- Resolves:rhbz#773348

* Wed Dec 14 2011 Justin Ross <jross@redhat.com> - 0.14-1
- Rebased to Qpid 0.14
- Spec file refactored

* Tue Oct 11 2011 Andrew Stitcher <astitcher@redhat.com> - 0.10-13
- Fixed dependency on qpid-java-jca

* Mon Oct 3 2011 Andrew Stitcher <astitcher@redhat.com> - 0.10-12
- Initial build.
